/* vim: set ts=2 sw=2 sts=2 et: */
/**
 * Password checking script
 * 
 * @category   X-Cart
 * @package    X-Cart
 * @subpackage JS Library
 * @author     Ruslan R. Fazlyev <rrf@x-cart.com> 
 * @version    $Id: check_password_script.js,v 1.2 2010/05/27 13:43:06 igoryan Exp $
 * @link       http://www.x-cart.com/
 * @see        ____file_see____
 */

function checkPasswordStrength(field1, field2) {
  var err = false;
  var field;
  var uname = '';

  if (!field1 || !field2)
    return !err;

  if (field1.form.elements.namedItem('password_is_modified') && field1.form.elements.namedItem('password_is_modified').value != 'Y')
    return !err;

  if (field1.value != field2.value) {
        markErrorField(field2);
    alert(txt_password_match_error);
    field2.focus();
    field2.select();
    return err;
  }
  else {
    field = field1;
    }

  if (field.form.elements.namedItem('uname'))
    uname = field.form.elements.namedItem('uname').value;
  if (field.form.elements.namedItem('username') && uname == '')
    uname = field.form.elements.namedItem('username').value;

  if (!(field.value.match(/.{7,}/) && field.value.match(/[a-z]/i) && field.value.match(/[0-9]/) && field.value.match(/\S/)) || uname == '' || field.value == uname) {
    err = true;
  }
  
  if (err) {
        markErrorField(field);
    alert(txt_simple_password);
    field.focus();
    field.select();
  }

  return !err;
}

